<template>
  <div class="query-display-panel d-flex flex-grow-1 flex-row">
    <!-- loading spinner -->
    <template v-if="loading">
      <div class="d-flex flex-grow-1">
        <div class="mx-auto my-auto">
          <h2 class="text-center mt-4">A carregar...</h2>
          <span class="align-middle">
            <clip-loader :loading="loading" color="#007bff" size="50px" radius="100%"/>
          </span>
        </div>
      </div>
    </template>

    <!-- error on download -->
    <template v-else-if="error">
      <div class="d-flex flex-grow-1">
        <div class="text-center mx-auto my-auto">
          <h1><font-awesome-icon icon="dizzy"></font-awesome-icon></h1>
          <div class="error-message">{{ error }}</div>
        </div>
      </div>
    </template>

    <template v-else>
      <div class="flex-grow-0 flex-row">
        <div class="skewt-container mx-2" ref="skewt"></div>
      </div>
      <div class="skewt-data-tables d-flex flex-grow-1 flex-row">
        <skewt-level-data-table :level-data="levelData"/>
        <skewt-surface-data-table :surface-data="surfaceData"/>
        <skewt-indices-data-table :indices-data="indicesData"/>
      </div>
    </template>
  </div>
</template>

<script>
import moment from 'moment'
import axios from 'axios'
import { Util } from 'leaflet'
import ClipLoader from 'vue-spinner/src/ClipLoader'
import WorkspaceGetter from '@/workspace/mixins/WorkspaceGetter'
import { skewT } from '@/core/skewt'
import SkewtSurfaceDataTable from '@/workspace/components/query/SkewtSurfaceDataTable'
import SkewtIndicesDataTable from '@/workspace/components/query/SkewtIndicesDataTable'
import SkewtLevelDataTable from '@/workspace/components/query/SkewtLevelDataTable'

export default {
  name: 'skewplotpanel',

  mixins: [
    WorkspaceGetter,
  ],

  props: {
    locationId: {
      type: String,
      required: true
    }
  },

  data() {
    return {
      loading: true,
      error: null,
      plotData: null,
      originalData: null,
      levelData: {},
    }
  },

  computed: {
    location: {
      get() {
        return this.$store.getters.workspaceLocationById(this.workspaceId, this.locationId)
      }
    },

    referenceTime: {
      get() {
        return this.$store.getters.workspaceReferenceTime(this.workspaceId)
      },
    },

    step: {
      get() {
        return this.$store.getters.workspaceStep(this.workspaceId)
      }
    },

    query: {
      get() {
        return this.$store.getters.workspaceQuery(this.workspaceId)
      }
    },

    queryRequestCache: {
      get() {
        return this.$store.getters.workspaceQueryRequestCache(this.workspaceId)
      }
    },

    surfaceTemperature: {
      get() {
        return Util.formatNum(this.originalData['2t'] - 272.15, 1) + ' ºC'
      }
    },
    surfaceDewpoint: {
      get() {
        return Util.formatNum(this.originalData['2d'] - 272.15, 1) + ' ºC'
      }
    },
    surfacePressure: {
      get() {
        return Util.formatNum(this.originalData.pressure / 100, 1) + ' hPa'
      }
    },
    cape: {
      get() {
        return Util.formatNum(this.originalData.cape, 1)
      }
    },
    cin: {
      get() {
        return Util.formatNum(this.originalData.cin, 1)
      }
    },
    totalx: {
      get() {
        return Util.formatNum(this.originalData.totalx, 1)
      }
    },

    surfaceData: {
      get() {
        return {
          intensity: this.originalData['10windint'],
          direction: this.originalData['10winddir'],
          temperature: this.originalData['2t'],
          dewpoint: this.originalData['2d'],
          pressure: this.originalData.pressure,
        }
      }
    },

    indicesData: {
      get() {
        return {
          cape: this.originalData.cape,
          cin: this.originalData.cin,
          totalx: this.originalData.totalx
        }
      }
    },
  },

  methods: {
    getData() {
      if('skewt' in this.$refs) this.$refs.skewt.innerHTML = ""

      this.loading = true
      this.error = null

      let baseUrl = process.env.VUE_APP_BASE_SKEWT_URL
      let url = baseUrl + Util.getParamString({
        reference_time: moment.unix(this.referenceTime).format('YYYY-MM-DDTHH:00:00[Z]'),
        time: moment.unix(this.referenceTime).add(this.step, 'hours').format('YYYY-MM-DDTHH:00:00[Z]'),
        latitude: this.location.latitude,
        longitude: this.location.longitude,
      })

      axios.get(url).then((response) => {
        this.originalData = response.data.properties
        this.plotData = response.data.properties.levels.map((level) => {
          return {
            ...level,
            press: level.press / 100.0,
            temp: level.temp - 272.15,
            dwpt: level.dwpt - 272.15,
          }
        })
        this.loading = false
      }).catch((e) => {
        window.console.log(e)
        this.error = 'Ocorreu um erro ao descarregar os dados. Por favor tente mais tarde.'
        this.loading = false
      })
    }
  },

  watch: {
    loading() {
      if(!this.loading && !this.error) {
        this.$nextTick(() => {
          this.plotter = skewT(this.$refs.skewt, [this.plotData])
          this.plotter.on('level-data-changed', (d) => {
            this.levelData = d
          })
        })
      }
    },

    step() {
      this.getData()
    }
  },

  mounted() {
    this.getData()
  },

  components: {
    ClipLoader,
    SkewtSurfaceDataTable,
    SkewtIndicesDataTable,
    SkewtLevelDataTable,
  },
}
</script>

<style>
.skewt-container {
  height: 300px;
  width: 40vh;
}

.gridline {
  stroke: #bfbfbf;
  stroke-width: 0.75px;
  fill: none;
}

.tempzero {
  stroke: #aaa;
  stroke-width: 1.25px;
}

.temp {
  fill: none;
  stroke: red;
  stroke-width: 3px;
}

.dwpt {
  fill: none;
  stroke: green;
  stroke-width: 3px;
}

.overlay {
  fill: none;
  pointer-events: all;
}

.focus.tmpc circle {
  fill: red;
  stroke: none;
}

.focus.dwptc circle {
  fill: green;
  stroke: none;
}

.focus text {
  font-size: 10px;
}

.focus.dwptc text {
  text-anchor: end;
}

.skewt-data-tables {
  min-width: 50vw;
}

.skewt-windbarbs {
  stroke: #000;
  stroke-width: 1.5px;
  fill: none;
}
</style>
